
#include <16F877.h>
#fuses HS,NOWDT,NOLVP,NODEBUG,PUT,BROWNOUT 
#use delay(clock = 16000000)
#use fast_io(B)
#use fast_io(D)

int8 hall,x;
int8 i,k,j=0;

int8 MoveTable[8] = {0, 33, 6, 36, 24, 9, 18, 0};

#INT_RB                                       // RB port interrupt on change
void rb_isr(void)
{
  hall = (input_b() >> 4) & 7;     
  delay_ms(5);
  output_d(MoveTable[hall]);
  //clear_interrupt(INT_RB);
  output_a(hall);
}
void main()
{
   set_tris_b(0xF0);
   //port_b_pullups(TRUE);                       // Enable PORTB internal pull-ups
  
  set_tris_d(0x00);
  set_tris_a(0x00);
  setup_timer_2(T2_DIV_BY_16, 250, 2);        // Set PWM frequency to 500Hz for 16MHz clock
   
  setup_ccp1(CCP_OFF);                        // CCP1 OFF
  enable_interrupts(GLOBAL);                
 setup_ccp1(CCP_PWM);
 set_pwm1_duty(125);    //duty=50%     for 8 bit (duty=value/PR2)
  
   
    hall = (input_b() >> 4) & 7;
    //clear_interrupt(INT_RB);              // Clear RB IOC flag bit
    enable_interrupts(INT_RB);
    while(1);
//!    
 // }
}

